@echo off

rem IsDirectory.bat
rem 2008-10-01
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 1 (
    set spec="%~1"
    call :run !spec!
  ) else (
    call :usage
  )

  goto :end

:run
  rem Double-quotes are needed below to handle '&' in file and directory names.
  set spec="%~1"
  set result=0

  dir /a:d %spec% > NUL 2>&1
  set error=%ERRORLEVEL%

  if %error% == 0 (
    echo 1
  ) else (
    echo 0
  )

  goto :EOF

:usage
  echo   Usage: "%scriptName%" "path"
  goto :EOF

:end
