@echo off

rem TakeControlOfContent.bat
rem 2008-10-01
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  setlocal
  set scriptPath=%~d0%~p0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 0 goto :help

  call :loop %*
  goto :end

:loop
  if ?%1? == ?? goto :EOF
  rem Following statement needs double-quote to handle '&'
  set spec="%~1"

  call SetVariableToOutput.bat IsDirectory.bat %spec%
  set result=%OutputVariable%

  if %result% == 1 call :processDir %spec%
  if %result% == 0 call :processFile %spec%

  shift
  goto :loop

:processDir
  call TakeControl %spec%
  for %%f in (%spec%\*) do call TakeControl.bat "%%f"
  for /D %%d in (%spec%\*) do call TakeControlOfContent.bat "%%d"
  goto :EOF

:processFile
  call TakeControl %spec%
  goto :EOF

:help
  echo   Usage: %~n0%~x0 "file/dir 1" [ . . . "file/dir N" ]

:end
